import java.text.*; // DecimalFormat ̂

public class Dft2 // Discrete Fourier Transform
{
  public static void dft(double fr[], double fi[], int mode)
  {
    //  Ut[GϊƋtϊ̌p
    // mode ̒l 1 ̎͐ϊCȊO͋tϊ
    int n;
    double gr[], gi[];

    n = fr.length;
    gr = new double[n];
    gi = new double[n];
    for (int k = 0; k < n; k++)
    {
      for (int j = 0; j < n; j++)
      {
        double v = 2.0 * Math.PI
         * (double)(k * j) / (double)n;
        double c = Math.cos(v);
        double s = Math.sin(v);
        if (mode != 1) s = -s;
        gr[k] += fr[j] * c - fi[j] * s; 
        gi[k] += fr[j] * s + fi[j] * c; 
      }
    }

    double wk = 1.0;
    if (mode == 1) wk = 1.0 / (double)n;
    for (int k = 0; k < n; k++)
    {
      fr[k] = wk * gr[k];
      fi[k] = wk * gi[k];
    }
  }

  public static void print(double fr[], double fi[])
  {
    String s;
    int n = fr.length;
    
    for (int k = 0; k < n; k++)
    {
      System.out.print(k + ", ");
      s = new DecimalFormat("#0.0000").format(fr[k]);
      System.out.print(s + ", ");
      s = new DecimalFormat("#0.0000").format(fi[k]);
      System.out.println(s);
    }
  }

  public static void main(String args[])
  {
     // 
    double fr[] = {0,  1,  1,  1,
                   0, -1, -1, -1};
    int n = fr.length; // f[^̌
    double fi[] = new double[n]; // 

    dft(fr, fi, 1); // ϊ
    System.out.println("@ϊ̌");
    System.out.println(" k, Fk(), Fk()");
    print(fr, fi);

    dft(fr, fi, 0); // tϊ
    System.out.println("@tϊ̌");
    System.out.println(" k, fk(), fk()");
    print(fr, fi);
  }
}
