public class Dft32 // Discrete Fourier Transform
{
  public static void dft(double f[],
   double gr[], double gi[])
  {
    int n;

    n = f.length;
    for (int k = 0; k < n; k++)
    {
      gr[k] = gi[k] = 0;
      for (int j = 0; j < n; j++)
      {
        double v = 2.0 * Math.PI
         * (double)(k * j) / (double)n;
        gr[k] += f[j] * Math.cos(v); 
        gi[k] += f[j] * Math.sin(v); 
      }
      gr[k] /= (double)n;
      gi[k] /= (double)n;
    }
  }

  public static void main(String args[])
  {
    double f[] = {1,  1,  1,  1,  1,  1,  1,  1, 
                  1,  1,  1,  1,  1,  1,  1,  1, 
                 -1, -1, -1, -1, -1, -1, -1, -1,
                 -1, -1, -1, -1, -1, -1, -1, -1};
    int n = f.length; // f[^̌
    double gr[] = new double[n]; // 
    double gi[] = new double[n]; // 

    dft(f, gr, gi);
    System.out.println(" k,   Fk(), Fk()");
    for (int i = 0; i < n; i++)
    {
      System.out.println(i + ", "
       + gr[i] + ", " + gi[i]);
    }
  }
}
