import java.text.*; // DecimalFormat ̂

public class Fft
{
  static int pow2(int n) // 2n(2^n) ߂
  {
    if (n <= 0) return 1;
    return 2 * pow2(n - 1);
  }

  static void fft(double fr[], double fi[], int m)
  {
    // t[Gϊ^tϊ
    // m ̎͐ϊƂC̎͋tϊ
    // m  n = 2^m ƂĂĝ
    //@𒲂ׂ琳̒lɂ
    double tr, ti, ur, ui, vr, vi, w, wr, wi;
    int   gap, g2, i, j, j2, k, mode, n, p;

    mode = 1; // ϊ
    if (m < 0) 
    {
      mode = 0; // tϊ
      m = -m; // m ̒l𐳂
    }
    n = pow2(m); // 2^m
    for (p = 0; p < m; p++)
    {
      gap = pow2(m - p); // 2^(m-p)
      g2  = gap / 2;
      for (k = 0; k < n; k += gap)
      {
        double v = 2.0 * Math.PI
         * (double)pow2(p) / (double)n;
        wr = Math.cos(v); // W^(2^p)
        wi = Math.sin(v);
        if (mode != 1) wi = -wi; // tϊ̎
        ur = 1.0; // U = (1.0, 0.0)
        ui = 0.0;
        for (j = k; j < k + g2; j++)
        {
          j2 = j + g2;
          vr = fr[j2]; // V = F[j2]
          vi = fi[j2];
          tr = fr[j] - vr; // T = (F[j] - F[j2])
          ti = fi[j] - vi;
          // F[j] = F[j] + F[j2]
          fr[j] += vr;
          fi[j] += vi;
          // F[jl] = U * (F[j] - F[j2])
          fr[j2] = tr * ur - ti * ui;
          fi[j2] = tr * ui + ti * ur;
          // U = U * W
          w  = ur * wr - ui * wi;
          ui = ur * wi + ui * wr;
          ur = w;
        }
      }
    }
    // rbgtёւ
    for (i = 0; i < n - 1; i++)
    {
      p = i;
      j = 0;
      // j = (i ̃rbgt)
      for (k = 0; k < m; k++)
      {
        j *= 2;
        j += p % 2;
        p /= 2;
      }
      if (i < j)
      {
        // vf̓ւ
        tr = fr[j];
        ti = fi[j];
        fr[j] = fr[i];
        fi[j] = fi[i];
        fr[i] = tr;
        fi[i] = ti;
      }
    }
    if (mode == 1)
    {
      // ϊ̎ n Ŋ
      w = 1.0 / (double)n;
      for (k = 0; k < n; k++)
      {
        fr[k] *= w;
        fi[k] *= w;
      }
    }
  }

  public static void print(double fr[], double fi[])
  {
    String s;
    int n = fr.length;
    
    for (int k = 0; k < n; k++)
    {
      System.out.print(k + ", ");
      s = new DecimalFormat("#0.0000").format(fr[k]);
      System.out.print(s + ", ");
      s = new DecimalFormat("#0.0000").format(fi[k]);
      System.out.println(s);
    }
  }

  public static void main(String args[])
  {
    double fr[] = { 0,  1,  1,  1,  1,  1,  1,  1,
                    0, -1, -1, -1, -1, -1, -1, -1};
    double fi[] = new double[fr.length];
    int m;

    m = 4; // f[^ 2^m Ƃ
    fft(fr, fi, m);
    System.out.println(" k, Fk(), Fk()");
    print(fr, fi);
  }
}
